# How To OpenSecurity Demo

## Installation

1. Copy the OpenSecurity parent Folder as-is to "C:\Program Files"

2. Inside this folder you find:

    OpenSecurity/
    ├── client  ............... OpenSecurity client code
    ├── cygwin  ............... A cygwin subsystem used inside OpenSecurity
    ├── gfx  .................. OpenSecurity images and icons used
    ├── install  .............. Necessary 3rd party installment
    └── server  ............... OpenSecuirty server code

3. Switch into the "install" folder. There you have:

    OpenSecurity/
    └── install/
        ├── OpenSecurity.reg
        ├── PyQt4-4.10.3-gpl-Py2.7-Qt4.8.5-x32.exe
        ├── PyQt4-4.10.3-gpl-Py2.7-Qt4.8.5-x64.exe
        ├── python-2.7.6.amd64.msi
        ├── python-2.7.6.msi
        ├── VirtualBox-4.3.4-91027-Win.exe
        └── web.py-0.37
    
    Please install the software via double-click:

    * python-2.7.6.msi on 32-Bit
        _or_ 
      python-2.7.6.amd64.msi on 64-Bit
      
    * PyQt4-4.10.3-gpl-Py2.7-Qt4.8.5-x32.exe on 32-Bit
        _or_
      PyQt4-4.10.3-gpl-Py2.7-Qt4.8.5-x64.exe on 64-Bit
    
    * VirtualBox-4.3.4-91027-Win.exe
    
    If you didn't change any settings you'll have a Win32 Python
    installation at C:\Python27 right now. This is important for 
    the next step.
    
    1. Open up a cmd box --> Start / Execute / "cmd"
    2. Switch into the OpenSecurity folder where the web.py resides:
    
        C:> cd C:\Program Files\OpenSecurity\install\web.py-0.37
        
    3. Install web.py by calling the setup.py with the "install" command
       from within a python shell:
       
        C:\Program Files\OpenSecurity\install\web.py-0.37> C:\Python27\python.exe setup.py install
        running install
        running build
        running build_py
        creating build
        creating build\lib
        creating build\lib\web
        copying web\application.py -> build\lib\web
        copying web\browser.py -> build\lib\web
        copying web\db.py -> build\lib\web
        copying web\debugerror.py -> build\lib\web
        copying web\form.py -> build\lib\web        
        ...

4. Finally update your registry by double-clicking the OpenSecurity.reg file.

5. To make changes in effect (automatically starting the OpenSecurity client and server daemons) you should restrat the machine.

NOTE: 
    Windows will pop up an UAC dialog for X11, OpenSecurity Client Daemon and OpenSecuirty Server Daemon

    
## VirtualBox VM Images

For the current setup to work you need at least a single Virtual Machine:

1. Create a Virtual Machine for Debian Linux
    --> The machine should be named 'Debian 7'
    --> There must be a user called 'user'

2. Have a Debian 7 (or 7.2) network installation ready and install a fresh new Debian system, with a user called 'user'.

3. Create 2 (!) Network Interfaces for your Virtual Machine
    a) The first will be set to "NAT" --> this will be eth0
    b) The second will be set to "Host-Only Adapter" --> this will be eth1

4. Power up the Virtual Machine and set the network interface configuration (/etc/network/interfaces) to:

    auto lo
    iface lo
    
    auto eth0
    allow-hotplug eth0
    iface eth0 inet dhcp
    
    auto eth1
    iface eth1 inet static
        address 192.168.56.101
        netmask 255.255.255.0
        gateway 192.168.56.1
        
5. Create a passwordless SSH connection from within Cygwin into the VM:

    a) ensure the VM is started and you have a user login called 'user'.
    b) start a cygwin shell by double-clicking "C:\Program Files\OpenSecurity\cygwin\Cygwin.vbs"
    c) generate a ssh-key
    
        $ ssh-keygen
        
        --> do not set passphrases, leave all to default
    d) copy the public key to the virtual machine
    
        $ scp ~/.ssh/id_rsa.pub user@192.168.56.101:
        
    e) add the public key to the list of authorized keys:
    
        - login into the virtual machine
        - open up a terminal
        
        $ mkdir ~/.ssh &> /dev/null
        $ cat id_rsa.pub >> ~/.ssh/authorized_keys
        
    f) test the passwordless connection by open the cyginw command prompt on the Windows Host again:
    
        $ ssh user@192.168.56.101
        
       --> this should now give you a login shell on the virtual machine without a password request.
        
        (you can now safely delete the id_rsa.pub file in your virtual machine's home)


## Demonstration

* Start the Virtual Machine
    --> You do not have to log in. Just start the machine. If the X11-Login Screen appears, all is done.
    
* Start the opensecurity-client by calling

    NOTE: you may omit this step if you double-clicked the OpenSecuirty.reg file previously.

    C:> C:\
    C:> cd "C:\Program Files\OpenSecurity\client"
    C:\Program Files\OpenSecurity\client> start "opensecurity_client_restful_server.py 8090"
    
    
* Open Up a browser and type:

    "http://127.0.0.1:8090"
    
    HAVE FUN! =D
